API/urls.py
from rest_framework import routers
from django.contrib import admin
from django.urls import path,include

from .viewsets import OtraCosaViewSet

app_name = "API"

router = routers.DefaultRouter()
router.register(u'cosas',OtraCosaViewSet)

urlpatterns = [
   path('',include(router.urls))
]

cosas/urls.py
from django.contrib import admin
from django.urls import path
from . import views
app_name = "cosas"

urlpatterns = [
   path('crear',views.crear,name="crear"),
   path('borrar/<int:id>',views.borrar,name="borrar"),
   path('actualizar/<int:id>',views.actualizar,name="actualizar"),
   path('otra-cosa/crear',views.otra_cosa_create,name="otra_cosa_crear"),
]

things/urls.py
from django.contrib import admin
from django.urls import path,include

from django.conf import settings
from django.conf.urls.static import static

from usuario.views import iniciar_sesion 

urlpatterns = [
    path('admin/', admin.site.urls),
    path('usuario/',include('usuario.urls',namespace="usuarios")),
    path('cosas/',include('cosas.urls',namespace="cosas")),
    path('login/',iniciar_sesion,name="iniciar_sesion"),
    path('api',include('API.urls'))
]
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

usuario/urls.py
from django.contrib import admin
from django.urls import path,include

app_name = 'usuarios'

from . import views
urlpatterns = [
  path('',views.index,name="index"),
  path('crear/',views.crear,name="crear"),
  path('cerrar_sesion',views.cerrar_sesion,name="cerrar_sesion")
]

cosas/models.py
from django.db import models

# Create your models here.
class TipoDeAlgo(models.Model):
    nombre = models.CharField(max_length=100)

class Algo(models.Model):
    nombre = models.CharField(max_length=100)
    cantidad = models.IntegerField()
    tipo = models.ForeignKey(TipoDeAlgo,on_delete=models.CASCADE)
    creado = models.DateTimeField(auto_now=True)
    foto = models.ImageField(upload_to="fotos",default="default.png")

    
class OtraCosa(models.Model):
    nombre = models.CharField(max_length=100)
    cantidad = models.IntegerField()
    correo = models.EmailField()
    tipo = models.ForeignKey(TipoDeAlgo,on_delete=models.CASCADE)
    creado = models.DateTimeField(auto_now=True)

    def __str__ (self):
        return self.nombre

usuario/models.py
from django.db import models

# Create your models here.

cosas/forms.py
from django import forms

from .models import OtraCosa

class OtraCosaForm(forms.ModelForm):
    class Meta():
        model = OtraCosa
        fields = ('nombre','cantidad','tipo','correo')

API/views.py
from django.shortcuts import render

# Create your views here.

cosas/views.py
from django.shortcuts import render
from django.contrib import messages
from django.urls import reverse
from django.http import HttpResponseRedirect
from django.contrib.auth.decorators import login_required
from django.contrib.admin.views.decorators import staff_member_required



from .models import TipoDeAlgo, Algo
from .forms import OtraCosaForm

def crear(request):
    if request.POST:
        nombre = request.POST.get('nombre','') 
        cantidad =request.POST.get('cantidad','') 
        tipo =  request.POST.get('tipo','')
        foto = request.FILES.get('foto',False)
        algo = Algo(nombre=nombre,cantidad=cantidad,tipo=TipoDeAlgo.objects.get(pk=tipo))
        if foto:
            algo.foto = foto    
        algo.save()
        messages.add_message(request, messages.INFO, 'Algo fue creado')

    context = {
        'lista_tda' : TipoDeAlgo.objects.all(),
        'lista_algo' : Algo.objects.all()
    }

    return render(request,'crear_cosas.html',context)

@login_required(login_url="/login")
def borrar(request,id):
    algo = Algo.objects.get(pk=id)
    algo.delete()
    messages.add_message(request, messages.INFO, 'Algo fue borrado')
    return HttpResponseRedirect(reverse('cosas:crear'))

@staff_member_required(login_url="/login")
def actualizar(request,id):
    algo = Algo.objects.get(pk=id)
    if request.POST:
        algo.nombre = request.POST.get('nombre','') 
        algo.cantidad =request.POST.get('cantidad','') 
        algo.tipo =  TipoDeAlgo.objects.get(pk=request.POST.get('tipo','') )
        algo.save()
        messages.add_message(request, messages.INFO, '{} fue editado'.format(algo.nombre))
        return HttpResponseRedirect(reverse('cosas:crear'))
    context = {
        'lista_tda' : TipoDeAlgo.objects.all(),
        'algo':algo
    }
    return render(request,'actualizar_cosas.html',context)

def otra_cosa_create(request):
    if request.POST:
        form = OtraCosaForm(request.POST)
        if form.is_valid():
            form.save()
            messages.add_message(request, messages.INFO, 'Otra cosa fue creada')
            return HttpResponseRedirect(reverse('cosas:crear'))
    else:
        form = OtraCosaForm()
    return render(request, 'otra_cosa_crear.html', {'form': form}) 

usuario/views.py
from django.shortcuts import render
from django.contrib import messages
from django.contrib.auth import authenticate, logout, login
from django.urls import reverse
from django.http import HttpResponseRedirect



def index(request):
    return render(request,'inicio.html',{})

def crear(request):
    contex = {'titulo':'Creación de usuario','verdadero':True}
    return render(request,'crear.html',contex)

def iniciar_sesion(request):
    if request.POST:
        usuario = request.POST.get('usuario',False)
        contrasenia = request.POST.get('contrasenia',False)
        
        if usuario and contrasenia:
            user = authenticate(request=request,username=usuario,
            password=contrasenia)
            if user is not None:
                login(request,user)
            else:
                messages.add_message(request, messages.INFO, 'Usuario incorrecto')
        else:
            messages.add_message(request, messages.INFO, 'Debes ingresar los datos')

    return render(request,'login.html')

def cerrar_sesion(request):
    logout(request)
    return HttpResponseRedirect(reverse('iniciar_sesion'))

cosas/templates/actualizar_cosas.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>
    <form action="{% url 'cosas:actualizar' algo.id %}" method="POST">
        {% csrf_token %}
        <label for="nombre">Nombre</label>
        <input type="text" name="nombre" value="{{algo.nombre}}">
        <br>
        <label for="cantidad">Cantidad</label>
        <input type="text" name="cantidad" value="{{algo.cantidad}}">
        <br>
        <label for="tipo">Tipo</label>
        <select name="tipo">
            {% for tda in lista_tda %}
                <option {% if tda.tipo == algo.tipo.id %} selected="selected" {% endif %}  value="{{tda.id}}">{{tda.nombre}}</option>
            {% endfor %}
        </select>
        <br>
        <button type="submit">Actualizar</button>
    </form> 
</body>
</html>

cosas/templates/crear_cosas.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>
    {% if user.is_authenticated %}
        <h4>{{user.username}}</h4>
        <a href="{% url 'usuarios:cerrar_sesion' %}">Cerrar sesión</a>
    {% else %}
        <a href="{% url 'iniciar_sesion' %}">Iniciar sesión</a>
    {% endif %}
    <nav>
        <ul>
            <li><a href="{% url 'cosas:otra_cosa_crear' %}">Crear Otra Cosa</a></li>
        </ul>
    </nav>
        {% if messages %}
        <ul class="messages">
            {% for message in messages %}
            <li{% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</li>
            {% endfor %}
        </ul>
        {% endif %}

    <form action="{% url 'cosas:crear' %}" method="POST" enctype="multipart/form-data">
        {% csrf_token %}
        <label for="nombre">Nombre</label>
        <input type="text" name="nombre">
        <br>
        <label for="cantidad">Cantidad</label>
        <input type="text" name="cantidad">
        <br>
        <label for="tipo">Tipo</label>
        <select name="tipo">
            {% for tda in lista_tda %}
            <option value="{{tda.id}}">{{tda.nombre}}</option>
            {% endfor %}
        </select>
        <br>
        <label for="foto">Foto</label>
        <input type="file" name="foto">
        <br>
        <button type="submit">Crear</button>
    </form> 

    <h2>Algo creados</h2>
    <table>
        <thead>
            <th>Foto</th>
            <th>Nombre</th>
            <th>Cantidad</th>
            <th>Tipo</th>
            <th>Creado</th>
            <th>Borrar</th>
            <th>Editar</th>
        </thead>
        <tbody>
            {% for algo in lista_algo %}
            <tr>
                <td><img src="{{algo.foto.url}}" height="60" width="60" alt="foto" ></td>
                <td>{{algo.nombre}}</td>
                <td>{{algo.cantidad}}</td>
                <td>{{algo.tipo.nombre}}</td>
                <td>{{algo.creado}}</td>
                {% if user.is_authenticated %}
                <td><a href="{% url 'cosas:borrar' algo.id %}">Borrar</a></td>
                {% endif %}
                {% if user.is_staff %}
                <td><a href="{% url 'cosas:actualizar' algo.id %}">Editar</a></td>
                {% endif %}
            </tr>    
            {% endfor %}
        </tbody>
    </table>
</body>
</html>

cosas/templates/otra_cosa_crear.html
<h2>Crear Otra Cosa</h2>
    <form method="POST" action="{% url 'cosas:otra_cosa_crear' %}" class="post-form">{% csrf_token %}
        {{ form.as_p }}
        <button type="submit" class="save btn btn-default">Save</button>
    </form>

usuario/templates/base.html
<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
    {% load static %}
    <style>
    
    h1{
        color:blue;
    }
    </style>
    {% block css %}
    {% endblock %}
</head>
<body>
    {% if user.is_authenticated %}
        <h4>{{user.username}}</h4>
        <a href="{% url 'usuarios:cerrar_sesion' %}">Cerrar sesión</a>
    {% else %}
        <a href="{% url 'iniciar_sesion' %}">Iniciar sesión</a>
    {% endif %}
    {% block contenido %}
    {% endblock %}

    {% block js %}
    {% endblock %}
    <script src="{% static 'js/app.js' %}"></script>
</body>
</html>

usuario/templates/crear.html
{% extends 'base.html' %}

{% block css %}
<style>
h3{
    color: rebeccapurple;
}
</style>
{% endblock %}

{% block contenido %}
<h1>{{titulo}}</h1>

{% if verdadero %}
    <h3>Es verdadero</h3>
{% else %}
    <h3>Es Falso</h3>
{% endif %}
{% endblock %}

usuario/templates/inicio.html
{% extends 'base.html' %}


{% block contenido %}
<h1>hoola mundo</h1>
<a href="{% url 'usuarios:crear' %}">Ir a crear</a>
{% endblock %}

usuario/templates/login.html
{% extends 'base.html' %}

{% block css %}
<style>
h3{
    color: rebeccapurple;
}
</style>
{% endblock %}

{% block contenido %}
<h2>Formulario</h2>
{% if messages %}
        <ul class="messages">
            {% for message in messages %}
            <li{% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</li>
            {% endfor %}
        </ul>
        {% endif %}
<form action="{% url 'iniciar_sesion' %}" method="post">
    {% csrf_token %}
    <label for="username">Username</label>
    <input type="text" name="usuario">
    <br>
    <label for="contrenia">Contraseña</label>
    <input type="password" name="contrasenia">
    <br>
    <button type="submit">Iniciar sesión</button>
</form>
{% endblock %}